package com.loafle.bridge.discoveryport;

import com.loafle.bridge.discoveryport.type.PortType;
import com.loafle.bridge.discoveryservice.DiscoveryService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import javax.transaction.Transactional;
import java.util.ArrayList;
import java.util.List;

/**
 * Created by root on 16. 11. 15.
 */

@RestController
public class DiscoveryPortController {

    @Autowired
    DiscoveryPortRepository repository;

    @RequestMapping(value = "/discoveryPort/{id}", method = RequestMethod.GET)
    public DiscoveryPort get(@PathVariable(value = "id") long id) {
        return repository.findOne(id);
    }

    @RequestMapping(value ="/index")
    @Transactional
    public void index() {
        DiscoveryPort p = new DiscoveryPort(PortType.TCP,(short)12786);

        List<DiscoveryService> ss = new ArrayList<>();

        repository.save(p);

        ss.add(new DiscoveryService(p,PortType.TCP,"DNS"));
        ss.add(new DiscoveryService(p,PortType.TCP,"TEST"));
        ss.add(new DiscoveryService(p,PortType.TCP,"ABB"));

        p.setServices(ss);

        repository.save(p);
    }
}
