package com.loafle.bridge.collector;

import com.loafle.bridge.Application;
import org.apache.log4j.Logger;
import org.junit.After;
import org.junit.Before;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.test.context.junit4.SpringJUnit4ClassRunner;

import java.util.Date;

import static org.junit.Assert.assertEquals;

/**
 * Created by root on 16. 11. 15.
 */

@RunWith(SpringJUnit4ClassRunner.class)
@ContextConfiguration(classes = Application.class)
public class CollectorRepositoryTest {



    @Autowired
    private CollectorRepository repo;

    Logger l = Logger.getLogger(this.getClass());


    @Before
    public void Before() {
        Collector c = new Collector();
        c.setVersion("1.0.0");
        c.setConfigPath("/root");
        c.setInstallDate(new Date());
        c.setUpdateDate(new Date());
        c.setLicenseDueDate(new Date());
        c.setProductId("1111111");
        repo.save(c);
    }

    @After
    public void After() {
        repo.deleteAll();
    }

    @Test
    public void TestInsertPort() {

        Collector c = new Collector();
        c.setVersion("1.0.0");
        c.setConfigPath("/root");
        c.setInstallDate(new Date());
        c.setUpdateDate(new Date());
        c.setLicenseDueDate(new Date());
        c.setProductId("1111111");
        repo.save(c);

        Collector res = repo.findOne(c.getId());

        assertEquals(c.getId(),res.getId());

    }


    @Test
    public void TestBefore() {
        assertEquals(1, repo.findAll().size());
    }

    @Test
    public void TestFindByProductId() {

        Collector c = repo.findAll().get(0);
        Collector find = repo.findByPID(c.getProductId());
        assertEquals(c.getId(),find.getId());


    }




}