package com.loafle.bridge.discoveryhost.repository;

import com.loafle.bridge.Application;
import com.loafle.bridge.discoveryhost.DiscoveryHost;
import com.loafle.bridge.discoveryhost.DiscoveryHostRepository;
import com.loafle.bridge.discoveryhost.PortScanHistory;
import com.loafle.bridge.discoveryport.type.DirectionType;
import com.loafle.bridge.discoveryport.type.PortType;
import org.apache.log4j.Logger;
import org.junit.After;
import org.junit.Before;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.test.context.junit4.SpringJUnit4ClassRunner;

import java.util.ArrayList;
import java.util.List;

import static org.junit.Assert.*;

/**
 * Created by root on 11/16/16.
 */

@RunWith(SpringJUnit4ClassRunner.class)
@ContextConfiguration(classes = Application.class)
public class DiscoveryHostRepositoryTest {

    @Autowired
    private DiscoveryHostRepository repository;

    Logger l = Logger.getLogger(this.getClass());

    @Before
    public void Before() {
        repository.save(new DiscoveryHost(3232235986l,52242420297l));
    }

    @After
    public void After() {
        repository.deleteAll();
    }

    @Test
    public void TestHost() {
        DiscoveryHost host = new DiscoveryHost(3232235986l,52242420297l);
        repository.save(host);

        DiscoveryHost c = repository.findOne(host.getId());

        assertEquals(host.getId(), c.getId());

        l.debug(c.getId());
        l.debug(c.getIpAddress());
        l.debug(c.getMacAddress());
        l.debug(c.getCreateDate());
        l.debug(c.getUpdateDate());

    }

    @Test
    public void TestPortHistory() {
        List<DiscoveryHost> list = repository.findAll();

        DiscoveryHost h = list.get(0);

        List<PortScanHistory> p = new ArrayList<PortScanHistory>();
        p.add(new PortScanHistory(h, (short)9840, PortType.TCP, DirectionType.Send,"DDDDDD"));

        h.setHistories(p);

        repository.flush();

        DiscoveryHost ff = repository.findOne(h.getId());

        System.out.println("ddddd"+ff.getId());

    }
}